package ru.dbotthepony.kstarbound.defs.world

import ru.dbotthepony.kstarbound.json.builder.IStringSerializable

enum class SpawnTime(override val jsonName: String, val day: Boolean, val night: Boolean) : IStringSerializable {
	ALL("all", true, true) {
		override fun isCompatible(other: SpawnTime): Boolean {
			return true
		}
	},

	DAY("day", true, false) {
		override fun isCompatible(other: SpawnTime): Boolean {
			return other.day
		}
	},

	NIGHT("night", false, true) {
		override fun isCompatible(other: SpawnTime): Boolean {
			return other.night
		}
	};

	abstract fun isCompatible(other: SpawnTime): Boolean
}
