package ru.dbotthepony.kstarbound.defs.world

import ru.dbotthepony.kommons.util.Either
import ru.dbotthepony.kstarbound.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.math.vector.Vector2d

@JsonFactory
data class WorldTemplateConfig(
	val playerStartSearchYRange: Int,

	val playerStartSearchTries: Int,
	val playerStartFreeBlocksRadius: Int,
	val playerStartFreeBlocksHeight: Int,

	val biomeTransitionThreshold: Double = 0.0,
	val customTerrainBlendSize: Double = 0.0,
	val surfaceCaveAttenuationDist: Double = 0.0,
	val surfaceCaveAttenuationFactor: Double = 1.0,

	val defaultGravity: Either<Vector2d, Double>,
) {
	val defaultGravityVector = defaultGravity.map({ it }, { Vector2d(0.0, it) })
}
